# Release Notes

[How to keep the changelog](https://keepachangelog.com/en/1.1.0/):

- `Added` for new features.
- `Changed` for changes in existing functionality.
- `Deprecated` for soon-to-be removed features.
- `Removed` for now removed features.
- `Fixed` for any bug fixes.
- `Security` in case of vulnerabilities.

## [Unreleased]

### Added

### Changed

### Deprecated

### Removed

### Fixed

### Security

## [1.0.0] (2024-03-08)

Release of v1. Now we move the development process to incremental updates with use of the changelog and semantic
versioning.
_Cooperative Cuisine_ **v1** is feature complete. It contains a usable _Overcooked!_-like environment, game server,
study server, 2D visualization, etc.

### Added

- continuous-like movement and pushing other players around
- extending recording, scoring, msgs via hooks at different programm points
- implemented random-action agent
- players connect via websockets
- 2D visualization with pygame
- Everything is configurable with config files: item info (ingredients, meals, etc.), layout, environment,
  visualization, study
- Game server that handles active environments
- Study environment with study server and study config. Does the match making
- For study participants: simple control tutorial, recipe guides, end screen.
- Controller support

### Security

- To manage environments on the game server, the "manager" needs to have a valid `manager_id` which is registered in the
  game server.
- Registered players (humans and agents) need to connect to websockets which were preregistered with a `client_id`.
- Each player actions need to reference a `player_hash` that should only be known by the player / client that
  controls the player.

## 0.1.0 (2023-11-23)

- Created