from argparse import ArgumentParser

from cooperative_cuisine.utils import (
    url_and_port_arguments,
    add_list_of_manager_ids_arguments,
    disable_websocket_logging_arguments,
    add_study_arguments,
    add_gui_arguments,
    create_layout_with_counters,
    setup_logging,
)


def test_parser_gen():
    parser = ArgumentParser()
    url_and_port_arguments(parser)
    disable_websocket_logging_arguments(parser)
    add_list_of_manager_ids_arguments(parser)
    add_study_arguments(parser)
    add_gui_arguments(parser)

    parser.parse_args(
        [
            "-s",
            "localhost",
            "-sp",
            "8000",
            "-g",
            "localhost",
            "-gp",
            "8080",
            "--manager-ids",
            "123",
            "123123",
            "--do-study",
        ]
    )


def test_layout_creation():
    assert """###\n#_#\n###\n""" == create_layout_with_counters(3, 3)
    assert """###\n#_#\n#_#\n###\n""" == create_layout_with_counters(3, 4)


def test_setup_logging():
    setup_logging()
